package ass.excercises.rest;

import io.reactivex.BackpressureStrategy;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import reactor.adapter.rxjava.RxJava2Adapter;
import reactor.core.publisher.Flux;
import ass.excercises.domain.Movie;
import ass.excercises.service.MovieService;

@RestController
public class MovieRestController {

	@Autowired
	protected MovieService service;
	
    @RequestMapping(path = "/movies", method = RequestMethod.GET, produces=MediaType.TEXT_EVENT_STREAM_VALUE)
	public Flux<Movie> movies() {
    	return RxJava2Adapter.observableToFlux(
    			service
    			.allMovies(), 
				BackpressureStrategy.BUFFER
		);
	}
	
}
