package ass.excercises.service;

import java.util.concurrent.TimeUnit;

import io.reactivex.Observable;

import org.apache.commons.lang3.RandomUtils;
import org.springframework.stereotype.Service;

import ass.excercises.domain.Movie;
import ass.excercises.domain.MovieName;
import ass.excercises.domain.MovieRating;

@Service
public class MovieService {

	public Observable<Movie> allMovies() {
		return Observable.just(
				"Silence of Lambdas",
				"Back to the CompletableFuture",
				"Enter the Single<Void>",
				"Asterisk wars"
		).map(name -> new Movie(new MovieName(name), new MovieRating(RandomUtils.nextInt(1, 6))))
		.flatMap(movie -> 
			Observable.just(movie).delay(RandomUtils.nextLong(500, 3000), TimeUnit.MILLISECONDS)
		);
	}
	
}
